VTK: vtkResliceCursorPicker Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkResliceCursorPicker Class Reference

ray-cast cell picker for the reslice cursor More...

`#include <vtkResliceCursorPicker.h>`

Inheritance diagram for vtkResliceCursorPicker:
[legend]
Collaboration diagram for vtkResliceCursorPicker:
[legend]

## Public Types
typedef vtkPicker | Superclass
Public Types inherited from vtkPicker
typedef vtkAbstractPropPicker | Superclass
Public Types inherited from vtkAbstractPropPicker
typedef vtkAbstractPicker | Superclass
Public Types inherited from vtkAbstractPicker
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkResliceCursorPicker * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | Pick (double selectionX, double selectionY, double selectionZ, vtkRenderer *renderer) override
| Perform pick operation with selection point provided. More...
virtual void | SetTransformMatrix (vtkMatrix4x4 *)
void | Pick (double displayPos[2], double world[3], vtkRenderer *ren)
| Overloaded pick method that returns the picked coordinates of the current resliced plane in world coordinates when given a display position. More...
virtual int | GetPickedAxis1 ()
| Get the picked axis. More...
virtual int | GetPickedAxis2 ()
| Get the picked axis. More...
virtual int | GetPickedCenter ()
| Get the picked axis. More...
virtual void | SetResliceCursorAlgorithm (vtkResliceCursorPolyDataAlgorithm *)
| Set the reslice cursor algorithm. More...
virtual vtkResliceCursorPolyDataAlgorithm * | GetResliceCursorAlgorithm ()
| Set the reslice cursor algorithm. More...
Public Member Functions inherited from vtkPicker
vtkPicker * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
vtkProp3DCollection * | GetProp3Ds ()
| Return a collection of all the prop 3D's that were intersected by the pick ray. More...
vtkActorCollection * | GetActors ()
| Return a collection of all the actors that were intersected. More...
vtkPoints * | GetPickedPositions ()
| Return a list of the points the actors returned by GetProp3Ds were intersected at. More...
int | Pick (double selectionX, double selectionY, double selectionZ, vtkRenderer *renderer) override
| Perform pick operation with selection point provided. More...
int | Pick (double selectionPt[3], vtkRenderer *ren)
| Perform pick operation with selection point provided. More...
int | Pick3DPoint (double selectionPt[3], vtkRenderer *ren) override
| Perform pick operation with selection point provided. More...
virtual int | Pick3DPoint (double p1World[3], double p2World[3], vtkRenderer *ren)
int | Pick3DRay (double selectionPt[3], double orient[4], vtkRenderer *ren) override
| Perform pick operation with selection point and orientation provided. More...
virtual void | SetTolerance (double)
| Specify tolerance for performing pick operation. More...
virtual double | GetTolerance ()
| Specify tolerance for performing pick operation. More...
virtual double * | GetMapperPosition ()
| Return position in mapper (i.e., non-transformed) coordinates of pick point. More...
virtual void | GetMapperPosition (double data[3])
| Return position in mapper (i.e., non-transformed) coordinates of pick point. More...
virtual vtkAbstractMapper3D * | GetMapper ()
| Return mapper that was picked (if any). More...
virtual vtkDataSet * | GetDataSet ()
| Get a pointer to the dataset that was picked (if any). More...
virtual vtkCompositeDataSet * | GetCompositeDataSet ()
| Get a pointer to the composite dataset that was picked (if any). More...
virtual vtkIdType | GetFlatBlockIndex ()
| Get the flat block index of the vtkDataSet in the composite dataset that was picked (if any). More...
Public Member Functions inherited from vtkAbstractPropPicker
vtkAbstractPropPicker * | NewInstance () const
virtual vtkProp * | GetViewProp ()
| Return the vtkProp that has been picked. More...
virtual vtkProp3D * | GetProp3D ()
| Return the vtkProp that has been picked. More...
virtual vtkActor * | GetActor ()
| Return the vtkActor that has been picked. More...
virtual vtkActor2D * | GetActor2D ()
| Return the vtkActor2D that has been picked. More...
virtual vtkVolume * | GetVolume ()
| Return the vtkVolume that has been picked. More...
virtual vtkAssembly * | GetAssembly ()
| Return the vtkAssembly that has been picked. More...
virtual vtkPropAssembly * | GetPropAssembly ()
| Return the vtkPropAssembly that has been picked. More...
virtual void | SetPath (vtkAssemblyPath *)
| Return the vtkAssemblyPath that has been picked. More...
virtual vtkAssemblyPath * | GetPath ()
| Return the vtkAssemblyPath that has been picked. More...
Public Member Functions inherited from vtkAbstractPicker
vtkAbstractPicker * | NewInstance () const
int | Pick (double selectionPt[3], vtkRenderer *ren)
| provided. More...
void | InitializePickList ()
| Initialize list of actors in pick list. More...
void | AddPickList (vtkProp *)
| Add an actor to the pick list. More...
void | DeletePickList (vtkProp *)
| Delete an actor from the pick list. More...
vtkPropCollection * | GetPickList ()
| Return the list of actors in the PickList. More...
virtual vtkRenderer * | GetRenderer ()
| Get the renderer in which pick event occurred. More...
virtual double * | GetSelectionPoint ()
| Get the selection point in screen (pixel) coordinates. More...
virtual void | GetSelectionPoint (double data[3])
| Get the selection point in screen (pixel) coordinates. More...
virtual double * | GetPickPosition ()
| Return position in global coordinates of pick point. More...
virtual void | GetPickPosition (double data[3])
| Return position in global coordinates of pick point. More...
virtual void | SetPickFromList (vtkTypeBool)
| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). More...
virtual vtkTypeBool | GetPickFromList ()
| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). More...
virtual void | PickFromListOn ()
| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). More...
virtual void | PickFromListOff ()
| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkResliceCursorPicker * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkResliceCursorPicker * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkPicker
static vtkPicker * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPicker * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractPropPicker
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractPropPicker * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractPicker
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractPicker * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkResliceCursorPicker ()
| ~vtkResliceCursorPicker () override
virtual int | IntersectPolyDataWithLine (double p1[3], double p2[3], vtkPolyData *, double tol)
virtual int | IntersectPointWithLine (double p1[3], double p2[3], double X[3], double tol)
void | TransformPlane ()
void | TransformPoint (double pIn[4], double pOut[4])
void | InverseTransformPoint (double pIn[4], double pOut[4])
Protected Member Functions inherited from vtkPicker
| vtkPicker ()
| ~vtkPicker () override
virtual int | Pick3DInternal (vtkRenderer *ren, double p1World[4], double p2World[4])
void | MarkPicked (vtkAssemblyPath *path, vtkProp3D *p, vtkAbstractMapper3D *m, double tMin, double mapperPos[3])
void | MarkPickedData (vtkAssemblyPath *path, double tMin, double mapperPos[3], vtkAbstractMapper3D *mapper, vtkDataSet *input, vtkIdType flatBlockIndex=-1)
virtual double | IntersectWithLine (const double p1[3], const double p2[3], double tol, vtkAssemblyPath *path, vtkProp3D *p, vtkAbstractMapper3D *m)
void | Initialize () override
Protected Member Functions inherited from vtkAbstractPropPicker
| vtkAbstractPropPicker ()
| ~vtkAbstractPropPicker () override
Protected Member Functions inherited from vtkAbstractPicker
| vtkAbstractPicker ()
| ~vtkAbstractPicker () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkGenericCell * | Cell
vtkResliceCursorPolyDataAlgorithm * | ResliceCursorAlgorithm
int | PickedAxis1
int | PickedAxis2
int | PickedCenter
vtkMatrix4x4 * | TransformMatrix
vtkPlane * | Plane
Protected Attributes inherited from vtkPicker
double | Tolerance
double | MapperPosition [3]
vtkAbstractMapper3D * | Mapper
vtkDataSet * | DataSet
vtkCompositeDataSet * | CompositeDataSet
vtkIdType | FlatBlockIndex
double | GlobalTMin
vtkTransform * | Transform
vtkActorCollection * | Actors
vtkProp3DCollection * | Prop3Ds
vtkPoints * | PickedPositions
Protected Attributes inherited from vtkAbstractPropPicker
vtkAssemblyPath * | Path
Protected Attributes inherited from vtkAbstractPicker
vtkRenderer * | Renderer
double | SelectionPoint [3]
double | PickPosition [3]
vtkTypeBool | PickFromList
vtkPropCollection * | PickList
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkPicker
static bool | CalculateRay (const double p1[3], const double p2[3], double ray[3], double &rayFactor)
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

ray-cast cell picker for the reslice cursor

This class is used by the vtkResliceCursorWidget to pick reslice axes drawn by a vtkResliceCursorActor. The class returns the axes picked if any, whether one has picked the center. It takes as input an instance of vtkResliceCursorPolyDataAlgorithm. This is all done internally by vtkResliceCursorWidget and as such users are not expected to use this class directly, unless they are overriding the behaviour of vtkResliceCursorWidget.

See also
  vtkResliceCursor vtkResliceCursorWidget

Events:
  vtkCommand::StartPickEvent

Definition at line 34 of file vtkResliceCursorPicker.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPicker vtkResliceCursorPicker::Superclass

Definition at line 38 of file vtkResliceCursorPicker.h.

## Constructor & Destructor Documentation

## ◆ vtkResliceCursorPicker()

vtkResliceCursorPicker::vtkResliceCursorPicker | ( |  | ) |
| protected

## ◆ ~vtkResliceCursorPicker()

vtkResliceCursorPicker::~vtkResliceCursorPicker | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkResliceCursorPicker* vtkResliceCursorPicker::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkResliceCursorPicker::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkResliceCursorPicker::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkPicker.

## ◆ SafeDownCast()

static vtkResliceCursorPicker* vtkResliceCursorPicker::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkResliceCursorPicker::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkPicker.

## ◆ NewInstance()

vtkResliceCursorPicker* vtkResliceCursorPicker::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkResliceCursorPicker::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ Pick() [1/2]

int vtkResliceCursorPicker::Pick | ( | double | selectionX,
|  | double | selectionY,
|  | double | selectionZ,
|  | vtkRenderer * | renderer
| ) |  |
| overridevirtual

Perform pick operation with selection point provided.

Normally the first two values are the (x,y) pixel coordinates for the pick, and the third value is z=0. The return value will be non-zero if something was successfully picked.

Implements vtkAbstractPicker.

## ◆ GetPickedAxis1()

virtual int vtkResliceCursorPicker::GetPickedAxis1 | ( |  | ) |
| virtual

Get the picked axis.

## ◆ GetPickedAxis2()

virtual int vtkResliceCursorPicker::GetPickedAxis2 | ( |  | ) |
| virtual

Get the picked axis.

## ◆ GetPickedCenter()

virtual int vtkResliceCursorPicker::GetPickedCenter | ( |  | ) |
| virtual

Get the picked axis.

## ◆ SetResliceCursorAlgorithm()

virtual void vtkResliceCursorPicker::SetResliceCursorAlgorithm | ( | vtkResliceCursorPolyDataAlgorithm * |  | ) |
| virtual

Set the reslice cursor algorithm.

One must be set

## ◆ GetResliceCursorAlgorithm()

virtual vtkResliceCursorPolyDataAlgorithm* vtkResliceCursorPicker::GetResliceCursorAlgorithm | ( |  | ) |
| virtual

Set the reslice cursor algorithm.

One must be set

## ◆ SetTransformMatrix()

virtual void vtkResliceCursorPicker::SetTransformMatrix | ( | vtkMatrix4x4 * |  | ) |
| virtual

## ◆ Pick() [2/2]

void vtkResliceCursorPicker::Pick | ( | double | displayPos[2],
|  | double | world[3],
|  | vtkRenderer * | ren
| ) |  |

Overloaded pick method that returns the picked coordinates of the current resliced plane in world coordinates when given a display position.

## ◆ IntersectPolyDataWithLine()

virtual int vtkResliceCursorPicker::IntersectPolyDataWithLine | ( | double | p1[3],
|  | double | p2[3],
|  | vtkPolyData * | ,
|  | double | tol
| ) |  |
| protectedvirtual

## ◆ IntersectPointWithLine()

virtual int vtkResliceCursorPicker::IntersectPointWithLine | ( | double | p1[3],
|  | double | p2[3],
|  | double | X[3],
|  | double | tol
| ) |  |
| protectedvirtual

## ◆ TransformPlane()

void vtkResliceCursorPicker::TransformPlane | ( |  | ) |
| protected

## ◆ TransformPoint()

void vtkResliceCursorPicker::TransformPoint | ( | double | pIn[4],
|  | double | pOut[4]
| ) |  |
| protected

## ◆ InverseTransformPoint()

void vtkResliceCursorPicker::InverseTransformPoint | ( | double | pIn[4],
|  | double | pOut[4]
| ) |  |
| protected

## Member Data Documentation

## ◆ Cell

vtkGenericCell* vtkResliceCursorPicker::Cell
| protected

Definition at line 86 of file vtkResliceCursorPicker.h.

## ◆ ResliceCursorAlgorithm

vtkResliceCursorPolyDataAlgorithm* vtkResliceCursorPicker::ResliceCursorAlgorithm
| protected

Definition at line 87 of file vtkResliceCursorPicker.h.

## ◆ PickedAxis1

int vtkResliceCursorPicker::PickedAxis1
| protected

Definition at line 89 of file vtkResliceCursorPicker.h.

## ◆ PickedAxis2

int vtkResliceCursorPicker::PickedAxis2
| protected

Definition at line 90 of file vtkResliceCursorPicker.h.

## ◆ PickedCenter

int vtkResliceCursorPicker::PickedCenter
| protected

Definition at line 91 of file vtkResliceCursorPicker.h.

## ◆ TransformMatrix

vtkMatrix4x4* vtkResliceCursorPicker::TransformMatrix
| protected

Definition at line 92 of file vtkResliceCursorPicker.h.

## ◆ Plane

vtkPlane* vtkResliceCursorPicker::Plane
| protected

Definition at line 93 of file vtkResliceCursorPicker.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkResliceCursorPicker.h